/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
/* Copyright (C) 1995, Ellemtel Telecommunications Systems Laboratories
 * Created:  27 Jul 1995 by tobbe@erix.ericsson.se
 * Function: Main routine to be linked with the IG generated stub code.
 *           If needed it will call the function pointed to by 'ig_init' .
 * RCS: $Id: igmain_init.c,v 1.4 1996/05/29 20:52:10 tobbe Exp $
 */
#include "ig.h"
#ifdef __WIN32__
#include <io.h>
#include <fcntl.h>
#else
#define O_BINARY 0
#define _setmode(fd, mode)
#endif

extern IG_PTR ig_init;
extern int ig_fun_in,ig_fun_out;
extern int ig_cback_in,ig_cback_out;

extern void igsetup_fun(int,int);
extern void igsetup_cback(int,int);
extern int ig_call(void);

int main(void)
{
  erl_init((Erl_Heap *) NULL, 0);
  _setmode(ig_fun_in, _O_BINARY);
  _setmode(ig_fun_out, _O_BINARY);
  igsetup_fun( ig_fun_in , ig_fun_out );
  _setmode(ig_cback_in, _O_BINARY);
  _setmode(ig_cback_out, _O_BINARY);
  igsetup_cback( ig_cback_in , ig_cback_out );
  if (ig_init != 0) ig_init();
  while (1) {
    if (ig_call() != IG_OK)
      exit(-1);
  }
}
